ru.bitel.bgbilling.modules.softkey.common.service

## Interface SoftkeyService

-     public interface SoftkeyService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `activate(int contractId, int count, int optionId)` Активация подписки
    `void` | `continueSubscription(int contractId, int optionId)` Продление подписки после ее приостановки по инициативе пользвателя
    `java.util.List<SoftkeyProduct>` | `getProductList()` Получение списка доступных подписок с сервера Softkey.
    `java.lang.String` | `getSubscribeStatus(int contractId)` Запрос актуального статуса подписки
    `SoftkeyTransaction` | `getTransactionByCid(int contractId, int optionId)` Получение подписки для конкретного договора по его номеру
    `SoftkeyTransaction` | `getTransactionById(int transactionId)` Получение подписки по ее номеру
    `java.util.List<SoftkeyTransaction>` | `getTransactionList(java.lang.String contractTitle, int status, java.util.Date fromDate, java.util.Date toDate)` Получение общего списка подписок
    `java.util.List<SoftkeyTransactionLog>` | `getTransactionLog(int transactionId)` получение лога транзакции по ее номеру
    `void` | `pause(int contractId, int optionId)` Приостановка подписки
    `void` | `stop(int contractId, int optionId)` Прекращение действия подписки
    `void` | `test()` Тестовый метод, для проверки работоспособности взаимодействия с сервисом

- - ### Method Detail

    - #### getTransactionList

          java.util.List<SoftkeyTransaction> getTransactionList(java.lang.String contractTitle,
                                                                int status,
                                                                java.util.Date fromDate,
                                                                java.util.Date toDate)
                                                         throws ru.bitel.bgbilling.common.BGException,
                                                                java.io.IOException

      Получение общего списка подписок
      Returns:
        список подписок, иначе - пустой список, если нет подписок
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### getTransactionById

          SoftkeyTransaction getTransactionById(int transactionId)
                                         throws ru.bitel.bgbilling.common.BGException,
                                                java.io.IOException

      Получение подписки по ее номеру
      Parameters:
        `transactionId` - номер подписки
      Returns:
        null, если подписки нет в базе
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### getTransactionByCid

          SoftkeyTransaction getTransactionByCid(int contractId,
                                                 int optionId)
                                          throws ru.bitel.bgbilling.common.BGException,
                                                 java.io.IOException

      Получение подписки для конкретного договора по его номеру
      Parameters:
        `cid` - номер договора
      Returns:
        null, если на договоре нет подписок
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### getTransactionLog

          java.util.List<SoftkeyTransactionLog> getTransactionLog(int transactionId)
                                                           throws ru.bitel.bgbilling.common.BGException,
                                                                  java.io.IOException

      получение лога транзакции по ее номеру
      Parameters:
        `transactionId` - номер транзакции
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### getProductList

          java.util.List<SoftkeyProduct> getProductList()
                                                 throws ru.bitel.bgbilling.common.BGException,
                                                        java.io.IOException

      Получение списка доступных подписок с сервера Softkey. Список всегда будет актуальным. В базе не хранится
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### activate

          void activate(int contractId,
                        int count,
                        int optionId)
                 throws ru.bitel.bgbilling.common.BGException,
                        java.io.IOException,
                        java.sql.SQLException

      Активация подписки
      Parameters:
        `count` - количество активируемых копий подписок
        `optionId` - код подписки
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.sql.SQLException`
        `java.io.IOException`

    - #### pause

          void pause(int contractId,
                     int optionId)
              throws ru.bitel.bgbilling.common.BGException,
                     java.io.IOException

      Приостановка подписки
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### continueSubscription

          void continueSubscription(int contractId,
                                    int optionId)
                             throws ru.bitel.bgbilling.common.BGException,
                                    java.io.IOException

      Продление подписки после ее приостановки по инициативе пользвателя
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### stop

          void stop(int contractId,
                    int optionId)
             throws ru.bitel.bgbilling.common.BGException,
                    java.io.IOException

      Прекращение действия подписки
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### getSubscribeStatus

          java.lang.String getSubscribeStatus(int contractId)
                                       throws ru.bitel.bgbilling.common.BGException,
                                              java.io.IOException

      Запрос актуального статуса подписки
      Parameters:
        `contractId` - номер договора
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`

    - #### test

          void test()
             throws ru.bitel.bgbilling.common.BGException,
                    java.io.IOException

      Тестовый метод, для проверки работоспособности взаимодействия с сервисом
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.io.IOException`